#ifndef NETEX_H
#define NETEX_H

#include <stdio.h>

#define PRINT(msg, args...) fprintf(stdout, msg, ##args)
#define PRINT_LINE(msg, args...) fprintf(stdout, msg "\n", ##args)
#define WARN(msg, args...) fprintf(stdout, "[Warning]: " msg "\n", ##args)
#define ERROR(msg, args...) fprintf(stderr, "[ERROR]: " msg "\n", ##args)

typedef enum socket_ipv
{
    IPv4,
    IPv6,
    Double
} SOCKET_IPV_TYPE;

typedef struct host_info
{
    char* ip;
    struct sockaddr* address;
    size_t addrlen;
    SOCKET_IPV_TYPE ipv_type;
} HOST_INFO;


void netex_init(void);
void netex_shutdown(void);
int setup_socket(int port, const char* hostname, SOCKET_IPV_TYPE ipv_type);
HOST_INFO* resolve_host(const char* hostname, int port, SOCKET_IPV_TYPE ipv_type);
void free_host_info(HOST_INFO* host_info);

#endif //NETEX_H